const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const collections = sequelize.define(
    'collections',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  collections.associate = (db) => {

    db.collections.belongsToMany(db.questions, {
      as: 'questions',
      foreignKey: {
        name: 'collections_questionsId',
      },
      constraints: false,
      through: 'collectionsQuestionsQuestions',
    });

    db.collections.belongsToMany(db.questions, {
      as: 'questions_filter',
      foreignKey: {
        name: 'collections_questionsId',
      },
      constraints: false,
      through: 'collectionsQuestionsQuestions',
    });


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.collections.belongsTo(db.users, {
      as: 'owner_user',
      foreignKey: {
        name: 'owner_userId',
      },
      constraints: false,
    });




    db.collections.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.collections.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return collections;
};


